// Fraktalas
//
//  2007 A-E Software 
// http://ae.dar.lt  aab@auto.lt
//
// Pradetas:
//      2007-11-24
// Paskutini karta redaguota:
//      2007-11-25


#include <windows.h>
#include <gl\gl.h>
#include <gl\glu.h>
#include <math.h>
#include <iostream>
using namespace std;

HDC			hDC=NULL;		   //GDI Device Context
HGLRC		hRC=NULL;		   //Permanent Rendering Context
HWND		hWnd=NULL;		   //Window Handle
HINSTANCE	hInstance;		   //Instance Of The Application

#include "geom_obj.h"
#include "fraktalas.h"
#include "kintamieji.h"
#include "funkcijos.h"

LRESULT	CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);	//WndProc

GLvoid LangasResize(GLsizei width, GLsizei height)		//Resize
{
	int w = width, h = height;

	if(height < 10)
		height = 10;

	if(((float)(width) / (float)(height)) < 1.3333f)
		height = (int)((((float)width) / 4.0f) * 3.0f);
	else if(((float)(width) / (float)(height)) > 1.3334f)
		width = (int)((((float)height) / 3.0f) * 4.0f);

	w = (w - width) / 2;
	h = (h - height) / 2;

	glViewport(w, h, width, height);

	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
}

int InitGL()										//OpenGL parametru nustatymas
{
	glShadeModel(GL_SMOOTH);
	glClearColor(0.2f, 0.2f, 0.2f, 1.0f);
	glClearDepth(1.0f);
	glDisable(GL_DEPTH_TEST);
	//glDepthFunc(GL_LEQUAL);
	glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);
	glEnable(GL_BLEND);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	glCullFace(GL_NONE);
	return true;
}

GLvoid LangasNaikinti()							//Naikinti langa
{
	if (langasFullscr){
		ChangeDisplaySettings(NULL,0);
		ShowCursor(TRUE);
	}

	if (hRC)											//Yra Rendering Context?
	{
		if (!wglMakeCurrent(NULL,NULL))					//Ar galima atlaisvinti DC ir RC Contextus?
		{
			MessageBox(NULL,"Klaida atlaisvinant DC ir RC","KLAIDA",MB_OK | MB_ICONINFORMATION);
		}

		if (!wglDeleteContext(hRC))						//Ar galima naikinti RC?
		{
			MessageBox(NULL,"Klaida atlaisvinant Rendering Context","KLAIDA",MB_OK | MB_ICONINFORMATION);
		}
		hRC=NULL;
	}

	if (hDC && !ReleaseDC(hWnd,hDC))					//Ar galima atlaisvinti DC
	{
		MessageBox(NULL,"Klaida atlaisvinant Device Context","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
		hDC=NULL;
	}

	if (hWnd && !DestroyWindow(hWnd))					//Ar galima naikinti langa?
	{
		MessageBox(NULL,"Klaida atlaisvinant hWnd.","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
		hWnd=NULL;
	}

	if (!UnregisterClass("OpenGL",hInstance))
	{
		MessageBox(NULL,"Klaida atlaisvinant hInstance","SHUTDOWN ERROR",MB_OK | MB_ICONINFORMATION);
		hInstance=NULL;
	}
}

BOOL LangasKurti()
{
	GLuint		PixelFormat;			//Holds The Results After Searching For A Match
	WNDCLASS	wc;						//Windows Class Structure
	DWORD		dwExStyle;				//Window Extended Style
	DWORD		dwStyle;				//Window Style
	RECT		WindowRect;				//Grabs Rectangle Upper Left / Lower Right Values
	WindowRect.left=(long)0;			//Left
	WindowRect.right=(long)langasX;		//Right
	WindowRect.top=(long)0;				//Top
	WindowRect.bottom=(long)langasY;	//Bottom

	hInstance			= GetModuleHandle(NULL);				//Grab An Instance For Our Window
	wc.style			= CS_HREDRAW | CS_VREDRAW | CS_OWNDC;	//Redraw On Size, And Own DC For Window.
	wc.lpfnWndProc		= (WNDPROC) WndProc;					//WndProc Handles Messages
	wc.cbClsExtra		= 0;									//No Extra Window Data
	wc.cbWndExtra		= 0;									//No Extra Window Data
	wc.hInstance		= hInstance;							//Set The Instance
	wc.hIcon			= LoadIcon(NULL, IDI_WINLOGO);			//Load The Default Icon
	wc.hCursor			= LoadCursor(NULL, IDC_ARROW);			//Load The Arrow Pointer
	wc.hbrBackground	= NULL;									//No Background Required For GL
	wc.lpszMenuName		= NULL;									//We Don't Want A Menu
	wc.lpszClassName	= "OpenGL";								//Set The Class Name

	if (!RegisterClass(&wc))									//Attempt To Register The Window Class
	{
		MessageBox(NULL,"Klaida registruojant \"wc\"","KLAIDA",MB_OK|MB_ICONEXCLAMATION);
		return FALSE;
	}

	if (langasFullscr)
	{
		DEVMODE dmScreenSettings;								//Device Mode
		memset(&dmScreenSettings,0,sizeof(dmScreenSettings));	//Isvalyti atminti
		dmScreenSettings.dmSize=sizeof(dmScreenSettings);
		dmScreenSettings.dmPelsWidth	= langasX;				//Lango plotis
		dmScreenSettings.dmPelsHeight	= langasY;				//Lango aukstis
		dmScreenSettings.dmBitsPerPel	= langasBpp;			//Bits per pixel
		dmScreenSettings.dmFields=DM_BITSPERPEL|DM_PELSWIDTH|DM_PELSHEIGHT;

		//NOTE: CDS_FULLSCREEN Gets Rid Of Start Bar.
		if (ChangeDisplaySettings(&dmScreenSettings,CDS_FULLSCREEN)!=DISP_CHANGE_SUCCESSFUL)
		{
			MessageBox(NULL,"Parinkti vaizdo nustatymai nesuderinami su Jusu sistema","KLAIDA",MB_OK|MB_ICONEXCLAMATION);
            return false;
		}
	}

	if (langasFullscr)											//Are We Still In Fullscreen Mode?
	{
		dwExStyle=WS_EX_APPWINDOW;								//Window Extended Style
		dwStyle=WS_POPUP;										//Windows Style
		ShowCursor(FALSE);										//Hide Mouse Pointer
	}
	else
	{
		dwExStyle=WS_EX_APPWINDOW | WS_EX_WINDOWEDGE;			//Window Extended Style
		dwStyle=WS_OVERLAPPEDWINDOW;							//Windows Style
	}

	AdjustWindowRectEx(&WindowRect, dwStyle, FALSE, dwExStyle);	//Adjust Window To True Requested Size

	//Kurti langa
	if (!(hWnd=CreateWindowEx(	dwExStyle,							//Extended Style For The Window
								"OpenGL",							//Class Name
								langasPav,							//Lango pavadinimas
								dwStyle |							//Defined Window Style
								WS_CLIPSIBLINGS |					//Required Window Style
								WS_CLIPCHILDREN,					//Required Window Style
								0, 0,								//Window Position
								WindowRect.right-WindowRect.left,	//Calculate Window Width
								WindowRect.bottom-WindowRect.top,	//Calculate Window Height
								NULL,								//No Parent Window
								NULL,								//No Menu
								hInstance,							//Instance
								NULL)))								//Dont Pass Anything To WM_CREATE
	{
		LangasNaikinti();
		MessageBox(NULL,"Klaida kuriant langa","KLAIDA",MB_OK|MB_ICONEXCLAMATION);
		return false;
	}

	static	PIXELFORMATDESCRIPTOR pfd=				//pfd Tells Windows How We Want Things To Be
	{
		sizeof(PIXELFORMATDESCRIPTOR),				//Size Of This Pixel Format Descriptor
		1,											//Version Number
		PFD_DRAW_TO_WINDOW |						//Format Must Support Window
		PFD_SUPPORT_OPENGL |						//Format Must Support OpenGL
		PFD_DOUBLEBUFFER,							//Must Support Double Buffering
		PFD_TYPE_RGBA,								//Request An RGBA Format
		langasBpp,									//Bits per pixel
		0, 0, 0, 0, 0, 0,							//Color Bits Ignored
		0,											//No Alpha Buffer
		0,											//Shift Bit Ignored
		0,											//No Accumulation Buffer
		0, 0, 0, 0,									//Accumulation Bits Ignored
		langasDepth,								//Z-Buferio gylis
		0,											//No Stencil Buffer
		0,											//No Auxiliary Buffer
		PFD_MAIN_PLANE,								//Main Drawing Layer
		0,											//Reserved
		0, 0, 0										//Layer Masks Ignored
	};

	if (!(hDC=GetDC(hWnd)))							//Did We Get A Device Context?
	{
		LangasNaikinti();
		MessageBox(NULL,"Klaida nustatant \"GL Device Context\"","KLAIDA",MB_OK|MB_ICONEXCLAMATION);
		return false;
	}

	if (!(PixelFormat=ChoosePixelFormat(hDC,&pfd)))	//Did Windows Find A Matching Pixel Format?
	{
		LangasNaikinti();
		MessageBox(NULL,"Klaida pasirenkant PixelFormat","KLAIDA",MB_OK|MB_ICONEXCLAMATION);
		return false;
	}

	if(!SetPixelFormat(hDC,PixelFormat,&pfd))		//Are We Able To Set The Pixel Format?
	{
		LangasNaikinti();
		MessageBox(NULL,"Klaida nustatant PixelFormat","KLAIDA",MB_OK|MB_ICONEXCLAMATION);
		return false;
	}

	if (!(hRC=wglCreateContext(hDC)))				//Are We Able To Get A Rendering Context?
	{
		LangasNaikinti();
		MessageBox(NULL,"Klaida kuriant \"GL Rendering Context\"","KLAIDA",MB_OK|MB_ICONEXCLAMATION);
		return false;
	}

	if(!wglMakeCurrent(hDC,hRC))					//Try To Activate The Rendering Context
	{
		LangasNaikinti();
		MessageBox(NULL,"Klaida aktyvuojant \"GL Rendering Context\"","KLAIDA",MB_OK|MB_ICONEXCLAMATION);
		return false;
	}

	ShowWindow(hWnd,SW_SHOW);						//Rodyti langa
	SetForegroundWindow(hWnd);						//Slightly Higher Priority
	SetFocus(hWnd);									//Sets Keyboard Focus To The Window
	LangasResize(langasX, langasY);					//Set Up Our Perspective GL Screen

	if (!InitGL())									//Inicializuoti langa
	{
		LangasNaikinti();
		MessageBox(NULL,"Klaida inicializuojant OpenGL","KLAIDA",MB_OK|MB_ICONEXCLAMATION);
		return false;
	}

	return true;
}

LRESULT CALLBACK WndProc(	HWND	hWnd,			//Handle For This Window
							UINT	uMsg,			//Message For This Window
							WPARAM	wParam,			//Additional Message Information
							LPARAM	lParam)			//Additional Message Information
{
	switch (uMsg)									//Check For Windows Messages
	{
		case WM_ACTIVATE:							//Watch For Window Activate Message
		{
			if (!HIWORD(wParam))					//Check Minimization State
				langasBaigti = false;
			else
				langasBaigti = true;
			return 0;
		}

		case WM_SYSCOMMAND:							//Intercept System Commands
		{
			switch (wParam)							//Check System Calls
			{
				case SC_SCREENSAVE:					//Jungiamas Sreensaveris?
				case SC_MONITORPOWER:				//Monitorius uzmigo?
				return 0;
			}
			break;
		}

		case WM_CLOSE:								//Gauta zinute Close?
		{
			PostQuitMessage(0);
			return 0;
		}

		case WM_KEYDOWN:							//Paspaustas spaudukas?
		{
			if(spaud[wParam] < 1)
				spaud[wParam] = 1;
			return 0;
		}

		case WM_KEYUP:								//Atleistas spaudukas?
		{
			spaud[wParam] = 0;
			return 0;
		}

		case WM_SIZE:								//Keisti lango dydi
		{
			LangasResize(LOWORD(lParam),HIWORD(lParam));  //LoWord=Width, HiWord=Height
			return 0;
		}
	}

	// Pass All Unhandled Messages To DefWindowProc
	return DefWindowProc(hWnd,uMsg,wParam,lParam);
}

int WINAPI WinMain(	HINSTANCE	hInstance,			//Instance
					HINSTANCE	hPrevInstance,		//Previous Instance
					LPSTR		lpCmdLine,			//Command Line Parameters
					int			nCmdShow)			//Window Show State
{
	MSG		msg;									//Windows Message Structure
	BOOL	done=FALSE;								//Bool Variable To Exit Loop

	Uzkrauti();

	if (!LangasKurti())
		return 0;

	cout<<"FRAKTALAS  (C) 2007 A-E Software (R)";
	cout<<"\n\nValdymas:";
	cout<<"\n  WSAD - judejimas";
	cout<<"\n  Rodykles - vaizdo pasukimas";
	cout<<"\n  K - koordinaciu sistemos piesimo ijungimas//isjungimas";
	cout<<"\n  Q - judejimo greicio padidinimas";
	cout<<"\n  Z - judejimo greicio sumazinimas";
	cout<<"\n\nFraktalo valdymas:";
	cout<<"\n  N, M - rekursijos gylio mazinimas/didinimas";
	cout<<"\n  V, B - mazejimo koeficiento mazinimas/didinimas";
	cout<<"\n  1, 2 - pasukimo kampo didinimas/mazinimas";

	while(!done)
	{
		if (PeekMessage(&msg,NULL,0,0,PM_REMOVE))	//Gauta zinute?
		{
			if (msg.message==WM_QUIT)
				done=TRUE;
			else
			{
				TranslateMessage(&msg);				//Translate The Message
				DispatchMessage(&msg);				//Dispatch The Message
			}
		}
		else
		{
			Valdymas();
			KameraSkaic();
			if ((!langasBaigti && !Piesti()) || spaud[VK_ESCAPE])
				done=TRUE;
			else
				SwapBuffers(hDC);
		}
	}

	//Baigti
	LangasNaikinti();
	return (msg.wParam);
}
